/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreVariable.TCoreVariablePath;
import de.ship.db.tables.TCoreVariableattrtype.TCoreVariableattrtypePath;
import de.ship.db.tables.records.TCoreVariableattrRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreVariableattr extends TableImpl<TCoreVariableattrRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_variableattr</code>
     */
    public static final TCoreVariableattr T_CORE_VARIABLEATTR = new TCoreVariableattr();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreVariableattrRecord> getRecordType() {
        return TCoreVariableattrRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_variableattr.lastchange</code>.
     */
    public final TableField<TCoreVariableattrRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("CURRENT_TIMESTAMP"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_variableattr.pk</code>.
     */
    public final TableField<TCoreVariableattrRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_variableattr.fk_variable</code>.
     * reference to variable
     */
    public final TableField<TCoreVariableattrRecord, Integer> FK_VARIABLE = createField(DSL.name("fk_variable"), SQLDataType.INTEGER.nullable(false), this, "reference to variable");

    /**
     * The column
     * <code>common_dd.t_core_variableattr.fk_variableattrtype</code>. reference
     * to variable attribute type
     */
    public final TableField<TCoreVariableattrRecord, Integer> FK_VARIABLEATTRTYPE = createField(DSL.name("fk_variableattrtype"), SQLDataType.INTEGER.nullable(false), this, "reference to variable attribute type");

    /**
     * The column <code>common_dd.t_core_variableattr.value</code>.
     */
    public final TableField<TCoreVariableattrRecord, JSONB> VALUE = createField(DSL.name("value"), SQLDataType.JSONB, this, "");

    private TCoreVariableattr(Name alias, Table<TCoreVariableattrRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreVariableattr(Name alias, Table<TCoreVariableattrRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_variableattr</code> table
     * reference
     */
    public TCoreVariableattr(String alias) {
        this(DSL.name(alias), T_CORE_VARIABLEATTR);
    }

    /**
     * Create an aliased <code>common_dd.t_core_variableattr</code> table
     * reference
     */
    public TCoreVariableattr(Name alias) {
        this(alias, T_CORE_VARIABLEATTR);
    }

    /**
     * Create a <code>common_dd.t_core_variableattr</code> table reference
     */
    public TCoreVariableattr() {
        this(DSL.name("t_core_variableattr"), null);
    }

    public <O extends Record> TCoreVariableattr(Table<O> path, ForeignKey<O, TCoreVariableattrRecord> childPath, InverseForeignKey<O, TCoreVariableattrRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_VARIABLEATTR);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreVariableattrPath extends TCoreVariableattr implements Path<TCoreVariableattrRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreVariableattrPath(Table<O> path, ForeignKey<O, TCoreVariableattrRecord> childPath, InverseForeignKey<O, TCoreVariableattrRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreVariableattrPath(Name alias, Table<TCoreVariableattrRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreVariableattrPath as(String alias) {
            return new TCoreVariableattrPath(DSL.name(alias), this);
        }

        @Override
        public TCoreVariableattrPath as(Name alias) {
            return new TCoreVariableattrPath(alias, this);
        }

        @Override
        public TCoreVariableattrPath as(Table<?> alias) {
            return new TCoreVariableattrPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreVariableattrRecord, Integer> getIdentity() {
        return (Identity<TCoreVariableattrRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreVariableattrRecord> getPrimaryKey() {
        return Keys.PK_CORE_VARIABLEATTR;
    }

    @Override
    public List<UniqueKey<TCoreVariableattrRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_VARIABLEATTR);
    }

    @Override
    public List<ForeignKey<TCoreVariableattrRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_VARIABLEATTR__FK_COREVARATTR_VARIABLE, Keys.T_CORE_VARIABLEATTR__FK_COREVARATTR_TYPE);
    }

    private transient TCoreVariablePath _tCoreVariable;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_variable</code>
     * table.
     */
    public TCoreVariablePath tCoreVariable() {
        if (_tCoreVariable == null)
            _tCoreVariable = new TCoreVariablePath(this, Keys.T_CORE_VARIABLEATTR__FK_COREVARATTR_VARIABLE, null);

        return _tCoreVariable;
    }

    private transient TCoreVariableattrtypePath _tCoreVariableattrtype;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_variableattrtype</code> table.
     */
    public TCoreVariableattrtypePath tCoreVariableattrtype() {
        if (_tCoreVariableattrtype == null)
            _tCoreVariableattrtype = new TCoreVariableattrtypePath(this, Keys.T_CORE_VARIABLEATTR__FK_COREVARATTR_TYPE, null);

        return _tCoreVariableattrtype;
    }

    @Override
    public TCoreVariableattr as(String alias) {
        return new TCoreVariableattr(DSL.name(alias), this);
    }

    @Override
    public TCoreVariableattr as(Name alias) {
        return new TCoreVariableattr(alias, this);
    }

    @Override
    public TCoreVariableattr as(Table<?> alias) {
        return new TCoreVariableattr(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVariableattr rename(String name) {
        return new TCoreVariableattr(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVariableattr rename(Name name) {
        return new TCoreVariableattr(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVariableattr rename(Table<?> name) {
        return new TCoreVariableattr(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableattr where(Condition condition) {
        return new TCoreVariableattr(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableattr where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableattr where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableattr where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariableattr where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariableattr where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariableattr where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariableattr where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableattr whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableattr whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
